// prefix header, with public (user-code-reachable) struct and typedef declarations
#include "FBtoC.h"
#include "Runtime.h"

/*
 FB runtime functions from Subs Containers.incl, adapted and edited to work (as part of Demo.bas) for container operations in C.
 Then FBtoC's translation was used to to populate this file, with editing where necessary to prevent gcc warnings.
 */

 
StringPtr GetCtnrString( Handle* srcCtnrVar, StringPtr s, long lstring )
{
	long              lgth;
	Handle            ctnrH;
	ctnrH = *srcCtnrVar;
	
	if ( lstring > 255 )
	{
		lstring = 255;
	}
	if ( ctnrH )
	{
		lgth = GetHandleSize( ctnrH );
		if ( lgth > lstring )  lgth = lstring;
		BlockMoveData( *ctnrH, s + 1, lgth );
	}
	else
	{
		lgth = 0;
	} 
	*s = lgth;
	
	return s;
} 

// simplificated 17-12-2006
StringPtr CatCtnrString( Handle* srcCtnrVar, StringPtr sPtr, long lstring )
{
	Str255            temp$;
	GetCtnrString( srcCtnrVar, (void*)&temp$, lstring );
	(PSstrcpy( TO_STACK, sPtr ), PSstrcat( TO_STACK, temp$ )); PSstrcpy( sPtr, TO_STACK );
	return sPtr;
} 


void FBCtnrCopy( Handle* srcCtnrVar, Handle* destCtnrVar )
{
	Handle            ctnrH;
	if ( srcCtnrVar != destCtnrVar )
	{
		ctnrH = *destCtnrVar;
		if ( ctnrH ) DisposeHandle( ctnrH );
		ctnrH = *srcCtnrVar;
		if ( ctnrH )  HandToHand( &ctnrH );
		*destCtnrVar = ctnrH;
	} 
} 


Handle * FBCtnrCopy3( Handle* destCtnrVar, Handle* srcCtnrVar )
{
	FBCtnrCopy( srcCtnrVar, destCtnrVar );
	return destCtnrVar;
} 


Handle FBNewContainer( long length )
{
	return NewHandle( length );
} 


Handle BuildContainer( Handle* ctnrVarPtr, long size )
{
	Handle            ctnrH;
	ctnrH =  *ctnrVarPtr;
	if ( ctnrH )
	{
		if ( size )
		{
			SetHandleSize( ctnrH, size );
		}
		else
		{
			DisposeHandle( ctnrH );
			*ctnrVarPtr = 0;
			ctnrH = 0;
		}
	}
	else
	{
		if ( size ) ctnrH = FBNewContainer( size );
	}
	*ctnrVarPtr = ctnrH;
	return ctnrH;
}


Handle * CtnrStoreString( void* ctnrVarPtr, Str255 t$_p )
{
	Str255 t$;  PSstrcpy( t$, t$_p );
	long              lgth;
	Handle            ctnrH;
	lgth = t$[0];
	ctnrH = BuildContainer( ctnrVarPtr, lgth );
	if ( ctnrH )
	{
		BlockMoveData( &t$[1], *ctnrH, lgth );
	}
	return ctnrVarPtr;
} 


long Asc_ctnr( Handle* ctnrVarPtr )
{
	Handle            ctnrHandle;
	long              theChar;
	ctnrHandle = *ctnrVarPtr;
	theChar = 0;
	if ( ctnrHandle )
	{
		theChar = GetHandleSize( ctnrHandle );
		if ( theChar )
		{
			theChar = *(unsigned char*)(*ctnrHandle);
		} 
	} 
	return theChar;
} 

// used for Unix tools only
void PrintContainer( Handle* ctnrVarPtr )
{
	long              l;
	long              p;
	long              c;
	Str255            t$;
	Handle            ctnrHandle;
	ctnrHandle = *ctnrVarPtr;
	if ( ctnrHandle )
	{
		l = GetHandleSize( ctnrHandle );
		p = 0;
		PSstrcpy( t$, "\p" );
		while ( -(p < l ) )
		{
			if ( t$[0] == 255 )
			{
				gFBPrintPos += printf( "%s", PScstr( PSstrcpy( TO_STACK, t$ ) ) );
				PSstrcpy( t$, "\p" );
			} 
			c = *(unsigned char*)(*ctnrHandle + p);
			p++;
			if ( c == 13 )
			{
				gFBPrintPos += printf( "%s", PScstr( PSstrcpy( TO_STACK, t$ ) ) );
				printf( "\n" ); gFBPrintPos = 0;
				PSstrcpy( t$, "\p" );
			}
			else
			{
				(PSstrcpy( TO_STACK, t$ ), PSstrcat( TO_STACK, PSstring( 1, c ) )); PSstrcpy( t$, TO_STACK );
			} 
		} /* 'while' */
	gFBPrintPos += printf( "%s", PScstr( PSstrcpy( TO_STACK, t$ ) ) );  
	} 
} 


Handle            gFBTempContainer;
Handle            gFBTemp2Container; // 20081020 #390 fix; used only for cntr vs string comparison


void FBClearTempContainer()
{
	if ( gFBTempContainer ) DisposeHandle( gFBTempContainer );
	gFBTempContainer = NULL;
} 

void FBClearTemp2Container()
{
    DisposeHandle( gFBTemp2Container );
    gFBTemp2Container = NULL;
} 


Handle * Left_Ctnr( Handle* ctnrVarPtr, long length )
{
	Handle            ctnrH;
	long              ctnrLen;
	Handle            newHndl;
	newHndl = NULL;
	ctnrH = *ctnrVarPtr;
	FBClearTempContainer();
	
	if ( ctnrH )
	{
		ctnrLen = GetHandleSize( ctnrH );
	}
	else
	{
		ctnrLen = 0;
	}
	if ( -(length > ctnrLen ) )
	{
		length = ctnrLen;
	}
	if ( -(length < 0 ) )
	{
		length = 0;
	}
	newHndl = FBNewContainer( length );
	if ( length )
	{
		BlockMoveData( (void*)*(ctnrH), (void*)*(newHndl), length );
	}
	gFBTempContainer = newHndl;
	return &gFBTempContainer;
} 


Handle * Right_Ctnr( Handle* ctnrVarPtr, long length )
{
	Handle            ctnrH;
	long              ctnrLen;
	Handle            newHndl;
	newHndl = NULL;
	ctnrH = *ctnrVarPtr;
	FBClearTempContainer();
	if ( ctnrH )
	{
		ctnrLen = GetHandleSize( ctnrH );
	}
	else
	{
		ctnrLen = 0;
	}
	if ( -(length > ctnrLen ) )
	{
		length = ctnrLen;
	}
	if ( -(length < 0 ) )
	{
		length = 0;
	}
	if ( length )
	{
		newHndl = FBNewContainer( length );
		BlockMoveData( (void*)*(ctnrH) + (ctnrLen - length), (void*)*(newHndl), length );
	}
	gFBTempContainer = newHndl;
	return &gFBTempContainer;
} 

//Handle * Mid_Ctnr( Handle * ctnrVarPtr, long startPos, long length )
//{
//	Handle              ctnrH;
//	long                ctnrLen;
//	Handle              newHndl;
//	newHndl = NULL;
//	startPos--;
//	if ( -(startPos < 0 ) )
//	{
//		startPos = 0;
//	}
//	ctnrH = *ctnrVarPtr;
//	FBClearTempContainer();
//	if ( ctnrH )
//	{
//		ctnrLen = GetHandleSize( ctnrH );
//	}
//	else
//	{
//		ctnrLen = 0;
//	}
//	if ( -(startPos > ctnrLen ) )
//	{
//		startPos = ctnrLen;
//	}
//	if ( -(length > ctnrLen - startPos ) )
//	{
//		length = ctnrLen - startPos;
//	}
//	if ( -(length < 0 ) )
//	{
//		length = 0;
//	}
//	if ( length )
//	{
//		newHndl = FBNewContainer( length );
//		BlockMoveData( *(ctnrH) + startPos, *(newHndl), length );
//	}
//	gFBTempContainer = newHndl;
//	return &gFBTempContainer;
//} 

Handle * Mid_Ctnr( Handle * ctnrVarPtr, long startPos, long length )
{
	Handle              ctnrH;
	long                ctnrLen;
    Handle              newHndl;
    newHndl = NULL;
	
	startPos--;
	if ( startPos < 0 )
	{
		startPos = 0;
	}
	ctnrH = *ctnrVarPtr;
    FBClearTempContainer();
	if ( ctnrH )
    {
		ctnrLen = GetHandleSize( ctnrH );
		// MN 2008-10-20
		if ( length < 0 )
		{
			length = ctnrLen;
		}
		// MN 2008-10-20                
	}
	else
    {
		ctnrLen = 0;
    }
	if ( startPos > ctnrLen )
	{
		startPos = ctnrLen;
	}
	if ( length > ctnrLen - startPos )
	{
		length = ctnrLen - startPos;
    }
	/*
	 // MN 2008-10-20
	 if ( -(length < 0 ) )
	 {
	 length = 0;
     }
	 */
    if ( length )
	{
		newHndl = FBNewContainer( length );
		BlockMoveData( *(ctnrH) + startPos, *newHndl, length );
	}
	gFBTempContainer = newHndl;
	return &gFBTempContainer;
}


Handle * AddStringToCtnr( Handle* ctnrVarPtr, Str255 t$_p )
{
	Str255 t$;  PSstrcpy( t$, t$_p );
	Handle            ctnrH;
	long              size1;
	long              size2;
	if ( ctnrVarPtr != &gFBTempContainer )
	{
		FBClearTempContainer();
	} 
	ctnrH =  *ctnrVarPtr;
	size2 = t$[0];
	if ( size2 )
	{
		if ( ctnrH == 0 )
		{
			size1 = 0;
			ctnrH = FBNewContainer( size2 );
			*ctnrVarPtr = ctnrH;
		}
		else
		{
			size1 = GetHandleSize( ctnrH );
			SetHandleSize( ctnrH, size1 + size2 );
		} 
		BlockMoveData( &t$[1], (void*)*ctnrH + size1, size2 );
	} 
	return ctnrVarPtr;
} 


Handle * AddCtnrs( Handle* ctnrV1Ptr, Handle* ctnrV2Ptr )
{
	Handle            ctnrH1;
	Handle            ctnrH2;
	long              size1;
	long              size2;
	ctnrH2 = *ctnrV2Ptr;
	if ( ctnrH2 )
	{
		ctnrH1 = *ctnrV1Ptr;
		if ( ctnrH1 == 0 )
		{
			ctnrH1 = NewHandle( 0 );
			*ctnrV1Ptr = ctnrH1;
		} 
		size1 = GetHandleSize( ctnrH1 );
		size2 = GetHandleSize( ctnrH2 );
		SetHandleSize( ctnrH1, size1 + size2 );
		BlockMoveData( *ctnrH2, (void*)*(ctnrH1) + size1, size2 );
	} 
	return ctnrV1Ptr;
} 


long Len_Ctnr( Handle* ctnrPtr )
{
	long              theLength;
	Handle            hand;
	hand = *ctnrPtr;
	theLength = 0;
	if ( hand )
	{
		theLength = GetHandleSize( hand );
	}
	return theLength;
} 

// bug fix
Handle * StringStr_Ctnr( long length, Str255 t$_p )
{
	Str255 t$;  PSstrcpy( t$, t$_p );
	gFBStk -= 1;
	long              i;
	long              c;
	Handle            newHndl;
	newHndl = NULL;
	FBClearTempContainer();
	if ( length )
	{
		newHndl = FBNewContainer( length );
		c = *(unsigned char*)((void*)&t$ + 1);
		i = 0; /* 'for' loop init */
		do /*  loop body */
		{
			// following line was not working in 1.0a68
			
			*(char*)( *(long*)(newHndl) + i ) = c;
			i += 1; /* step */
		}
		while ( i <= length - 1);
	} 
	gFBTempContainer = newHndl;
	return &gFBTempContainer;
} 


long FBCompareHandles( Handle h1, Handle h2 )
{
	void*             c1Ptr;
	void*             c2Ptr;
	void*             e1Ptr;
	long              chkPos;
	long              ccLen1;
	long              cLen2;
	chkPos = -(-(h1 != h2 ));
	if ( chkPos )
	{
		if ( (long)(h1) )
		{
			if ( (long)(h2) )
			{
				ccLen1 = GetHandleSize( h1 );
				cLen2 = GetHandleSize( h2 );
				c1Ptr = (void*)( *(long*)(h1) );
				c2Ptr = (void*)( *(long*)(h2) );
				if ( -(cLen2 < ccLen1 ) )
				{
					e1Ptr = (void*)( c1Ptr + cLen2 );
				}
				else
				{
					e1Ptr = (void*)( c1Ptr + ccLen1 );
				} 
				while ( -(c1Ptr < e1Ptr ) )
				{
					if ( -(*(unsigned char*)c1Ptr != *(unsigned char*)c2Ptr ) )
					{
						goto LL1;
					} 
					c1Ptr++;
					c2Ptr++;
				} /* 'while' */
			LL1: ;
				chkPos = (long)(((long)(c1Ptr - *(long*)(h1))) + 1);
				if ( -(c1Ptr == e1Ptr ) )
				{
					if ( -(ccLen1 <= cLen2 ) )
					{
						if ( -(ccLen1 < cLen2 ) )
						{
							chkPos = -chkPos;
						}
						else
						{
							chkPos = 0;
						} 
					} 
				}
				else
				{
					if ( -(*(unsigned char*)c1Ptr < *(unsigned char*)c2Ptr ) )
					{
						chkPos = -chkPos;
					} 
				} 
			} 
		}
		else
		{
			chkPos = -1;
		} 
	} 
	return chkPos;
} 


long FBCompareContainers( Handle* ctnr1, Handle* ctnr2 )
{
	return FBCompareHandles( *ctnr1, *ctnr2 );
} 

//Boolean FBCmpCtnr( Handle* Ctnr1, Handle* Ctnr2 )
//{
//	return (FBCompareHandles( *Ctnr1, *Ctnr2 ) != 0);
//} 


Boolean FBCmpCtnr( Handle* ctnr1, Handle* ctnr2 ) // #390 fix
{
    Boolean res = (FBCompareHandles( *ctnr1, *ctnr2 ) != 0);
    FBClearTemp2Container();
    return res;
} 


/*
 Not optimized. The original FB fn uses the gFBUpperChar_UBA table.
 */

Handle * UCase_Ctnr( Handle* ctnrVarPtr )
{
	Handle            ctnrH;
	long              length;
	Handle            newHndl;
	newHndl = NULL;
	char *            cPtr;
	
	ctnrH = *ctnrVarPtr;
	FBClearTempContainer();
	if ( ctnrH )
	{
		length = GetHandleSize( ctnrH );
	}
	else
	{
		length = 0;
	}
	if ( length )
	{
		newHndl = FBNewContainer( length );
		cPtr = *(newHndl);
		BlockMoveData( (void*)*(long*)(ctnrH), cPtr, length );
		length = length + (long)cPtr;
		while ( (-( (long)cPtr < length )) )
		{
			//			*(unsigned char*)cPtr = gFBUpperChar_UBA[*(unsigned char*)cPtr];
#if !__LP64__
			UppercaseText( cPtr, 1, -2 );
#else
			*cPtr = toupper( *cPtr );
#endif  /* !__LP64__ */

			cPtr++;
		}
	}
	gFBTempContainer = newHndl;
	return &gFBTempContainer;
} 

// The same as STRINGSTR_CTNR with ascii value instead of string as second parameter
// 19-12-2006
Handle * StringNum_Ctnr( long length, long c )
{
	long              i;
	Handle            newHndl;
	newHndl = NULL;
	FBClearTempContainer();
	if ( length )
	{
		newHndl = FBNewContainer( length );
		i = 0;
		do
		{
			// following line was not working in 1.0a68
			
			*(char*)( *(long*)(newHndl) + i ) = c;
			i += 1; /* step */
		}
		while ( i <= length - 1);
	} 
	gFBTempContainer = newHndl;
	return &gFBTempContainer;
} 


long MidStmt_Ctnr( Handle* ctnrVarPtr, long position_L, long length, Str255 st$_p )
{
	Str255 st$;  PSstrcpy( st$, st$_p );
	gFBStk -= 1;
	long              i;
	long              SrcLen_L;
	long              DstLen_L;
	long              StrvPtr_L;
	Handle            ctnrH;
	
	SrcLen_L = PSlen( PSstrcpy( STACK_PUSH, st$ ) );
	if ( length < 0 )
	{
		length = SrcLen_L;
	}
	if (position_L < 1 )
	{
		position_L = 1;
	}
	ctnrH = *ctnrVarPtr;
	if ( ctnrH )
	{
		StrvPtr_L = *(long*)(ctnrH);
		DstLen_L = GetHandleSize( ctnrH );
		if ( length > DstLen_L )
		{
			length = DstLen_L;
		}
		if ( length > SrcLen_L )
		{
			length = SrcLen_L;
		}
		if ( length > 0 )
		{
			position_L--;
			i = 1;
			do
			{
				*(char*)( StrvPtr_L + position_L + i - 1 ) = *(unsigned char*)((void*)&st$ + i);
				i += 1;
			}
			while ( (1 >= 0 && i <= length) || (1 < 0 && i >= length) );
		}
	}
	return 0;
} 


long MidStmt_Ctnr_Ctnr( Handle* ctnrVarPtr, long position_L, long length, Handle* srcCtnrVar )
{
	long              i;
	long              SrcLen_L;
	long              DstLen_L;
	Handle            srcHndl;
	Handle            ctnrH;
	long              StrvPtr_L;
	
	srcHndl = *srcCtnrVar;
	if ( srcHndl )
	{
		SrcLen_L = GetHandleSize( srcHndl );
		if ( -(length < 0 ) )
		{
			length = SrcLen_L;
		}
		if ( -(position_L < 1 ) )
		{
			position_L = 1;
		}
		ctnrH = *ctnrVarPtr;
		if ( ctnrH )
		{
			StrvPtr_L = *(long*)(ctnrH);
			DstLen_L = GetHandleSize( ctnrH );
			if ( -(length > DstLen_L ) )
			{
				length = DstLen_L;
			}
			if ( -(length > SrcLen_L ) )
			{
				length = SrcLen_L;
			}
			if ( -(length > 0 ) )
			{
				position_L--;
				i = 1; /* 'for' loop init */
				do /*  loop body */
				{
					*(char*)( StrvPtr_L + position_L + i - 1 ) = *(unsigned char*)(*(long*)(srcHndl) + i - 1);
					i += 1; /* step */
				}
				while ( (1 >= 0 && i <= length) || (1 < 0 && i >= length) );
			}
		}
	}
	return 0;
} 



long Instr_Ctnr( long position_L, Handle* BigctnrVarPtr, Handle* SearchctnrVarPtr )
{
	long              FoundPos_L;
	long              CmpLen_L;
	FoundPos_L = 0;
	if ( *BigctnrVarPtr )
	{
		if ( *SearchctnrVarPtr )
		{
			if ( -(position_L >= 0 ) )
			{
				CmpLen_L = GetHandleSize( *SearchctnrVarPtr );
				FoundPos_L = Munger( *BigctnrVarPtr, position_L - 1, *(*SearchctnrVarPtr), CmpLen_L, 0, 0 );
				if ( -(FoundPos_L < 0 ) )
				{
					FoundPos_L = 0;
				}
				else
				{
					FoundPos_L++;
				}
			}
		}
	}
	return FoundPos_L;
} 


long Instr_Ctnr_PStr( long position_L, Handle* BigctnrVarPtr, Str255 st$_p )
{
	Str255 st$;  PSstrcpy( st$, st$_p );
	gFBStk -= 1;
	long              FoundPos_L;
	
	FoundPos_L = 0;
	if ( *BigctnrVarPtr )
	{
		if ( -(position_L >= 0 ) )
		{
			FoundPos_L = Munger( *BigctnrVarPtr, position_L - 1, ((void*)&st$ + 1), st$[0], 0, 0 );
			if ( -(FoundPos_L < 0 ) )
			{
				FoundPos_L = 0;
			}
			else
			{
				FoundPos_L++;
			}
		}
	}
	return FoundPos_L;
} 

void CtnrStoreResID( long  userID, Handle * destCtnrVar )
{
	Handle            ctnrH;
	ctnrH = *destCtnrVar;
	if ( ctnrH )
	{
		DisposeHandle( ctnrH );
	}
	ctnrH = GetResource( 'TEXT', userID );
	if ( ctnrH )
	{
		DetachResource( ctnrH );
		//FBCtnrCheckMemErr( 0, PSstrcpy( STACK_PUSH, "\pin CTNRSTORERESID" ) );
	}
	*destCtnrVar = ctnrH;
} 

